From 8e3eb5d1e6ee6d42ab592722d65e998cde3a2067 Mon Sep 17 00:00:00 2001
From: "Paul A. Jungwirth" <pj@illuminatedcomputing.com>
Date: Thu, 30 Jul 2026 12:48:16 -0700
Subject: [PATCH v1 7/7] Add SET NULL/SET DEFAULT for temporal foreign keys

Like CASCADE, these actions need FOR PORTION OF, and they must handle
the same scenarios. Again the only complicated one is an UPDATE without
FOR PORTION OF. The behavior is similar to CASCADE, but not exactly the same:
we never delete any history in the referencing table. For any history that was
kept in the referenced table, we do nothing. For any history that was lost, we
do an UPDATE FOR PORTION OF to change the reference to NULL/DEFAULT. If the
referenced key's scalar part changed, then we consider the row's whole history
to be lost, regardless of its new application time.

Author: Paul A. Jungwirth <pj@illuminatedcomputing.com>
---
 doc/src/sgml/ddl.sgml                         |    4 +-
 doc/src/sgml/ref/create_table.sgml            |   18 +-
 src/backend/commands/tablecmds.c              |   47 +-
 src/backend/utils/adt/ri_triggers.c           |  126 +-
 .../regress/expected/without_overlaps.out     | 1641 +++++++++++++++--
 src/test/regress/sql/without_overlaps.sql     |  705 ++++++-
 6 files changed, 2295 insertions(+), 246 deletions(-)

diff --git a/doc/src/sgml/ddl.sgml b/doc/src/sgml/ddl.sgml
index bc7d3f0220c..a550a57143a 100644
--- a/doc/src/sgml/ddl.sgml
+++ b/doc/src/sgml/ddl.sgml
@@ -1861,8 +1861,8 @@ CREATE TABLE variants (
 
     <para>
      <productname>PostgreSQL</productname> supports temporal foreign keys with
-     action <literal>NO ACTION</literal>, <literal>RESTRICT</literal>, and
-     <literal>CASCADE</literal>, but not <literal>SET NULL</literal> or
+     action <literal>NO ACTION</literal>, <literal>RESTRICT</literal>,
+     <literal>CASCADE</literal>, <literal>SET NULL</literal>, and
      <literal>SET DEFAULT</literal>.
     </para>
    </sect3>
diff --git a/doc/src/sgml/ref/create_table.sgml b/doc/src/sgml/ref/create_table.sgml
index 1805b503089..b69a6fd64bc 100644
--- a/doc/src/sgml/ref/create_table.sgml
+++ b/doc/src/sgml/ref/create_table.sgml
@@ -1361,7 +1361,14 @@ WITH ( MODULUS <replaceable class="parameter">numeric_literal</replaceable>, REM
          </para>
 
          <para>
-          In a temporal foreign key, this option is not supported.
+          In a temporal foreign key, the change will use <literal>FOR PORTION
+          OF</literal> semantics to constrain the effect to the bounds being
+          deleted/updated in the referenced row. If an update shortens the
+          referenced row's application time but leaves the rest of the key
+          alone, then only the time that was lost is set to null, since the
+          referencing rows are still valid for the time that was kept. The
+          column marked with <literal>PERIOD</literal> cannot be set to
+          null.
          </para>
         </listitem>
        </varlistentry>
@@ -1378,7 +1385,14 @@ WITH ( MODULUS <replaceable class="parameter">numeric_literal</replaceable>, REM
          </para>
 
          <para>
-          In a temporal foreign key, this option is not supported.
+          In a temporal foreign key, the change will use <literal>FOR PORTION
+          OF</literal> semantics to constrain the effect to the bounds being
+          deleted/updated in the referenced row. If an update shortens the
+          referenced row's application time but leaves the rest of the key
+          alone, then only the time that was lost is set to a default value,
+          since the referencing rows are still valid for the time that was
+          kept. The column marked with <literal>PERIOD</literal> cannot be
+          set to a default value.
          </para>
         </listitem>
        </varlistentry>
diff --git a/src/backend/commands/tablecmds.c b/src/backend/commands/tablecmds.c
index 769a3d9f043..2a1b7956683 100644
--- a/src/backend/commands/tablecmds.c
+++ b/src/backend/commands/tablecmds.c
@@ -585,7 +585,7 @@ static ObjectAddress ATAddForeignKeyConstraint(List **wqueue, AlteredTableInfo *
 											   Relation rel, Constraint *fkconstraint,
 											   bool recurse, bool recursing,
 											   LOCKMODE lockmode);
-static int	validateFkOnDeleteSetColumns(int numfks, const int16 *fkattnums,
+static int	validateFkOnDeleteSetColumns(int numfks, const int16 *fkattnums, const int16 fkperiodattnum,
 										 int numfksetcols, int16 *fksetcolsattnums,
 										 List *fksetcols);
 static ObjectAddress addFkConstraint(addFkConstraintSides fkside,
@@ -10167,6 +10167,7 @@ ATAddForeignKeyConstraint(List **wqueue, AlteredTableInfo *tab, Relation rel,
 	int16		fkdelsetcols[INDEX_MAX_KEYS] = {0};
 	bool		with_period;
 	bool		pk_has_without_overlaps;
+	int16		fkperiodattnum = InvalidAttrNumber;
 	int			i;
 	int			numfks,
 				numpks,
@@ -10264,15 +10265,20 @@ ATAddForeignKeyConstraint(List **wqueue, AlteredTableInfo *tab, Relation rel,
 									 fkconstraint->fk_attrs,
 									 fkattnum, fktypoid, fkcolloid);
 	with_period = fkconstraint->fk_with_period || fkconstraint->pk_with_period;
-	if (with_period && !fkconstraint->fk_with_period)
-		ereport(ERROR,
-				errcode(ERRCODE_INVALID_FOREIGN_KEY),
-				errmsg("foreign key uses PERIOD on the referenced table but not the referencing table"));
+	if (with_period)
+	{
+		if (!fkconstraint->fk_with_period)
+			ereport(ERROR,
+					(errcode(ERRCODE_INVALID_FOREIGN_KEY),
+					 errmsg("foreign key uses PERIOD on the referenced table but not the referencing table")));
+		fkperiodattnum = fkattnum[numfks - 1];
+	}
 
 	numfkdelsetcols = transformColumnNameList(RelationGetRelid(rel),
 											  fkconstraint->fk_del_set_cols,
 											  fkdelsetcols, NULL, NULL);
 	numfkdelsetcols = validateFkOnDeleteSetColumns(numfks, fkattnum,
+												   fkperiodattnum,
 												   numfkdelsetcols,
 												   fkdelsetcols,
 												   fkconstraint->fk_del_set_cols);
@@ -10369,26 +10375,6 @@ ATAddForeignKeyConstraint(List **wqueue, AlteredTableInfo *tab, Relation rel,
 					 errmsg("foreign key constraints on virtual generated columns are not supported")));
 	}
 
-	/*
-	 * Some actions are currently unsupported for foreign keys using PERIOD.
-	 */
-	if (fkconstraint->fk_with_period)
-	{
-		if (fkconstraint->fk_upd_action == FKCONSTR_ACTION_SETNULL ||
-			fkconstraint->fk_upd_action == FKCONSTR_ACTION_SETDEFAULT)
-			ereport(ERROR,
-					errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
-					errmsg("unsupported %s action for foreign key constraint using PERIOD",
-						   "ON UPDATE"));
-
-		if (fkconstraint->fk_del_action == FKCONSTR_ACTION_SETNULL ||
-			fkconstraint->fk_del_action == FKCONSTR_ACTION_SETDEFAULT)
-			ereport(ERROR,
-					errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
-					errmsg("unsupported %s action for foreign key constraint using PERIOD",
-						   "ON DELETE"));
-	}
-
 	/*
 	 * Look up the equality operators to use in the constraint.
 	 *
@@ -10740,6 +10726,7 @@ ATAddForeignKeyConstraint(List **wqueue, AlteredTableInfo *tab, Relation rel,
  */
 static int
 validateFkOnDeleteSetColumns(int numfks, const int16 *fkattnums,
+							 const int16 fkperiodattnum,
 							 int numfksetcols, int16 *fksetcolsattnums,
 							 List *fksetcols)
 {
@@ -10750,6 +10737,16 @@ validateFkOnDeleteSetColumns(int numfks, const int16 *fkattnums,
 		int16		setcol_attnum = fksetcolsattnums[i];
 		bool		seen = false;
 
+		/* Make sure it isn't the PERIOD column */
+		if (fkperiodattnum == setcol_attnum)
+		{
+			char	   *col = strVal(list_nth(fksetcols, i));
+
+			ereport(ERROR,
+					(errcode(ERRCODE_INVALID_COLUMN_REFERENCE),
+					 errmsg("column \"%s\" referenced in ON DELETE SET action cannot be PERIOD", col)));
+		}
+
 		/* Make sure it's in fkattnums[] */
 		for (int j = 0; j < numfks; j++)
 		{
diff --git a/src/backend/utils/adt/ri_triggers.c b/src/backend/utils/adt/ri_triggers.c
index 6a8fdc042df..f90b027a48e 100644
--- a/src/backend/utils/adt/ri_triggers.c
+++ b/src/backend/utils/adt/ri_triggers.c
@@ -461,8 +461,10 @@ static void tri_foreach_lost_range(const RI_ConstraintInfo *riinfo,
 								   TupleTableSlot *newslot,
 								   tri_lost_range_callback callback, void *arg);
 static void tri_cascade_del_lost_range(Datum lostRange, void *arg);
+static void tri_set_lost_range(Datum lostRange, void *arg);
 static void ri_restrict_lost_range(Datum lostRange, void *arg);
 
+
 /*
  * RI_FKey_check -
  *
@@ -720,6 +722,7 @@ RI_FKey_check(TriggerData *trigdata)
 	return PointerGetDatum(NULL);
 }
 
+
 /*
  * RI_FKey_check_ins -
  *
@@ -735,6 +738,7 @@ RI_FKey_check_ins(PG_FUNCTION_ARGS)
 	return RI_FKey_check((TriggerData *) fcinfo->context);
 }
 
+
 /*
  * RI_FKey_check_upd -
  *
@@ -750,6 +754,7 @@ RI_FKey_check_upd(PG_FUNCTION_ARGS)
 	return RI_FKey_check((TriggerData *) fcinfo->context);
 }
 
+
 /*
  * ri_Check_Pk_Match
  *
@@ -881,6 +886,7 @@ ri_Check_Pk_Match(Relation pk_rel, Relation fk_rel,
 	return result;
 }
 
+
 /*
  * RI_FKey_noaction_del -
  *
@@ -1216,6 +1222,7 @@ ri_restrict(TriggerData *trigdata, bool is_no_action)
 	return PointerGetDatum(NULL);
 }
 
+
 /*
  * RI_FKey_cascade_del -
  *
@@ -1339,6 +1346,7 @@ RI_FKey_cascade_del(PG_FUNCTION_ARGS)
 	return PointerGetDatum(NULL);
 }
 
+
 /*
  * RI_FKey_cascade_upd -
  *
@@ -1505,6 +1513,7 @@ RI_FKey_cascade_upd(PG_FUNCTION_ARGS)
 	return PointerGetDatum(NULL);
 }
 
+
 /*
  * RI_FKey_setnull_del -
  *
@@ -1626,7 +1635,7 @@ ri_set(TriggerData *trigdata, bool is_set_null, int tgkind)
 		char		paramname[16];
 		const char *querysep;
 		const char *qualsep;
-		Oid			queryoids[RI_MAX_NUMKEYS];
+		Oid			queryoids[RI_MAX_NUMKEYS + 1];	/* +1 for FOR PORTION OF */
 		const char *fk_only;
 		int			num_cols_to_set;
 		const int16 *set_cols;
@@ -1634,7 +1643,12 @@ ri_set(TriggerData *trigdata, bool is_set_null, int tgkind)
 		switch (tgkind)
 		{
 			case RI_TRIGTYPE_UPDATE:
-				num_cols_to_set = riinfo->nkeys;
+
+				/*
+				 * For temporal keys, leave the range column to FOR PORTION
+				 * OF.
+				 */
+				num_cols_to_set = riinfo->hasperiod ? riinfo->nkeys - 1 : riinfo->nkeys;
 				set_cols = riinfo->fk_attnums;
 				break;
 			case RI_TRIGTYPE_DELETE:
@@ -1651,7 +1665,7 @@ ri_set(TriggerData *trigdata, bool is_set_null, int tgkind)
 				}
 				else
 				{
-					num_cols_to_set = riinfo->nkeys;
+					num_cols_to_set = riinfo->hasperiod ? riinfo->nkeys - 1 : riinfo->nkeys;
 					set_cols = riinfo->fk_attnums;
 				}
 				break;
@@ -1671,8 +1685,16 @@ ri_set(TriggerData *trigdata, bool is_set_null, int tgkind)
 		fk_only = fk_rel->rd_rel->relkind == RELKIND_PARTITIONED_TABLE ?
 			"" : "ONLY ";
 		quoteRelationName(fkrelname, fk_rel);
-		appendStringInfo(&querybuf, "UPDATE %s%s SET",
-						 fk_only, fkrelname);
+		if (riinfo->hasperiod)
+		{
+			quoteOneName(attname,
+						 RIAttName(fk_rel, riinfo->fk_attnums[riinfo->nkeys - 1]));
+			appendStringInfo(&querybuf, "UPDATE %s%s FOR PORTION OF %s ($%d) SET",
+							 fk_only, fkrelname, attname, riinfo->nkeys + 1);
+		}
+		else
+			appendStringInfo(&querybuf, "UPDATE %s%s SET",
+							 fk_only, fkrelname);
 
 		/*
 		 * Add assignment clauses
@@ -1709,21 +1731,65 @@ ri_set(TriggerData *trigdata, bool is_set_null, int tgkind)
 			queryoids[i] = pk_type;
 		}
 
+		/* For temporal keys, set a param for FOR PORTION OF TO/FROM */
+		if (riinfo->hasperiod)
+			queryoids[riinfo->nkeys] = RIAttType(pk_rel,
+												 riinfo->pk_attnums[riinfo->nkeys - 1]);
+
 		/* Prepare and save the plan */
-		qplan = ri_PlanCheck(querybuf.data, riinfo->nkeys, queryoids,
-							 &qkey, fk_rel, pk_rel);
+		qplan = ri_PlanCheck(querybuf.data,
+							 riinfo->hasperiod ? riinfo->nkeys + 1 : riinfo->nkeys,
+							 queryoids, &qkey, fk_rel, pk_rel);
 	}
 
 	/*
 	 * We have a plan now. Run it to update the existing references.
+	 *
+	 * For a non-temporal key we set every matching row.  For a temporal key
+	 * we only touch the history that changed: an UPDATE that kept the scalar
+	 * key loses history one span at a time (computed with the without_portion
+	 * SRF), while any other case targets the old row's application time
+	 * (possibly intersected with an original FOR PORTION OF).
 	 */
-	ri_PerformCheck(riinfo, &qkey, qplan,
-					fk_rel, pk_rel,
-					oldslot, NULL,
-					-1, (Datum) 0,
-					false,
-					true,		/* must detect new rows */
-					SPI_OK_UPDATE);
+	if (!riinfo->hasperiod)
+	{
+		ri_PerformCheck(riinfo, &qkey, qplan,
+						fk_rel, pk_rel,
+						oldslot, NULL,
+						-1, (Datum) 0,
+						false,
+						true,	/* must detect new rows */
+						SPI_OK_UPDATE);
+	}
+	else if (tgkind == RI_TRIGTYPE_UPDATE &&
+			 pk_scalar_keys_equal(riinfo, oldslot, trigdata->tg_newslot))
+	{
+		TRI_SetContext ctx;
+
+		ctx.riinfo = riinfo;
+		ctx.qkey = &qkey;
+		ctx.qplan = qplan;
+		ctx.fk_rel = fk_rel;
+		ctx.pk_rel = pk_rel;
+		ctx.oldslot = oldslot;
+
+		/* Update the referencing history, one lost span at a time */
+		tri_foreach_lost_range(riinfo, oldslot, trigdata->tg_newslot,
+							   tri_set_lost_range, &ctx);
+	}
+	else
+	{
+		Datum		targetRange = restrict_enforced_range(trigdata->tg_temporal,
+														  riinfo, oldslot);
+
+		ri_PerformCheck(riinfo, &qkey, qplan,
+						fk_rel, pk_rel,
+						oldslot, NULL,
+						riinfo->nkeys + 1, targetRange,
+						false,
+						true,	/* must detect new rows */
+						SPI_OK_UPDATE);
+	}
 
 	if (SPI_finish() != SPI_OK_FINISH)
 		elog(ERROR, "SPI_finish failed");
@@ -1751,6 +1817,7 @@ ri_set(TriggerData *trigdata, bool is_set_null, int tgkind)
 	}
 }
 
+
 /*
  * tri_cascade_del -
  *
@@ -2582,11 +2649,13 @@ RI_PartitionRemove_Check(Trigger *trigger, Relation fk_rel, Relation pk_rel)
 	AtEOXact_GUC(true, save_nestlevel);
 }
 
+
 /* ----------
  * Local functions below
  * ----------
  */
 
+
 /*
  * quoteOneName --- safely quote a single SQL name
  *
@@ -2771,6 +2840,7 @@ ri_CheckTrigger(FunctionCallInfo fcinfo, const char *funcname, int tgkind)
 	}
 }
 
+
 /*
  * Fetch the RI_ConstraintInfo struct for the trigger's FK constraint.
  */
@@ -3032,6 +3102,7 @@ InvalidateConstraintCacheCallBack(Datum arg, SysCacheIdentifier cacheid,
 	}
 }
 
+
 /*
  * Prepare execution plan for a query to enforce an RI restriction
  */
@@ -4254,6 +4325,7 @@ ri_ReportViolation(const RI_ConstraintInfo *riinfo,
 				 errtableconstraint(fk_rel, NameStr(riinfo->conname))));
 }
 
+
 /*
  * ri_NullCheck -
  *
@@ -4292,6 +4364,7 @@ ri_NullCheck(TupleDesc tupDesc,
 	return RI_KEYS_SOME_NULL;
 }
 
+
 /*
  * ri_InitHashTables -
  *
@@ -4326,6 +4399,7 @@ ri_InitHashTables(void)
 								   &ctl, HASH_ELEM | HASH_BLOBS);
 }
 
+
 /*
  * ri_FetchPreparedPlan -
  *
@@ -4378,6 +4452,7 @@ ri_FetchPreparedPlan(RI_QueryKey *key)
 	return NULL;
 }
 
+
 /*
  * ri_HashPreparedPlan -
  *
@@ -4406,6 +4481,7 @@ ri_HashPreparedPlan(RI_QueryKey *key, SPIPlanPtr plan)
 	entry->plan = plan;
 }
 
+
 /*
  * ri_KeysEqual -
  *
@@ -4497,6 +4573,7 @@ ri_KeysEqual(Relation rel, TupleTableSlot *oldslot, TupleTableSlot *newslot,
 	return true;
 }
 
+
 /*
  * ri_CompareWithCast -
  *
@@ -4651,6 +4728,7 @@ ri_HashCompareOp(Oid eq_opr, Oid typeid)
 	return entry;
 }
 
+
 /*
  * Given a trigger function OID, determine whether it is an RI trigger,
  * and if so whether it is attached to PK or FK relation.
@@ -5273,6 +5351,26 @@ tri_cascade_del_lost_range(Datum lostRange, void *arg)
 					lostRange);
 }
 
+/*
+ * tri_set_lost_range -
+ *
+ * tri_foreach_lost_range callback for ON UPDATE SET NULL/SET DEFAULT: runs the
+ * prepared UPDATE against one span the referenced row lost.
+ */
+static void
+tri_set_lost_range(Datum lostRange, void *arg)
+{
+	TRI_SetContext *ctx = (TRI_SetContext *) arg;
+
+	ri_PerformCheck(ctx->riinfo, ctx->qkey, ctx->qplan,
+					ctx->fk_rel, ctx->pk_rel,
+					ctx->oldslot, NULL,
+					ctx->riinfo->nkeys + 1, lostRange,
+					false,
+					true,		/* must detect new rows */
+					SPI_OK_UPDATE);
+}
+
 /*
  * ri_restrict_lost_range -
  *
